#include <gio/gio.h>
#include <gnio/gsocket.h>
#include <gnio/ginetsocketaddress.h>
#include <gnio/ginet4address.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <sys/socket.h>

GMainLoop *loop;

void
accept_callback (GSocket *socket, GAsyncResult *result, gpointer data)
{
	GError *error = NULL;

	if (!g_socket_connect_finish (socket, result, &error)) {
		g_warning ("error connecting: %s", error->message);
		return;
	}

	g_print ("successfully connected\n");
}

int main (int argc, char *argv[])
{
	GSocket *socket;

	g_thread_init (NULL);

	g_type_init ();

	loop = g_main_loop_new (NULL, FALSE);

	socket = g_socket_new (AF_INET, SOCK_STREAM, 0);

	g_printf ("connecting to 127.0.0.1:31882...\n");

	g_socket_connect_async (socket, G_SOCKET_ADDRESS (g_inet_socket_address_new (G_INET_ADDRESS (g_inet4_address_from_string ("127.0.0.1")), 31882)), NULL, (GAsyncReadyCallback) accept_callback, NULL);

	g_main_loop_run (loop);

	return 0;
}
